image: ${CI_DEPENDENCY_PROXY_GROUP_IMAGE_PREFIX}/edbizarro/gitlab-ci-pipeline-php:7.4

stages:
  - deploy-prod-prepare
  - deploy-prod

variables:
  CI_REPO_URL: "https://gitlab.com/kravets1996/kazinsys-ci/-/raw/main"

.ssh-key-install: &ssh-key-install
  - 'which ssh-agent || ( apt-get update -y && apt-get install openssh-client -y )'
  - eval $(ssh-agent -s)
  - ssh-add <(echo "$SSH_PRODUCTION_KEY")
  - mkdir -p ~/.ssh
  - echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config

.push-from-prod:
  stage: deploy-prod-prepare
  before_script:
    - *ssh-key-install
  script:
    - curl -LO "${CI_REPO_URL}/bitrix-projects/legacy/push-prod.sh"
    - chmod +x push-prod.sh

    - export CMD="cd ${PRODUCTION_ROOTPATH} && bash -s"
    - ssh -p ${PRODUCTION_SSH_PORT} ${PRODUCTION_USER}@${PRODUCTION_HOST} "${CMD}" < ./push-prod.sh ${CI_PROJECT_ID} ${GITLAB_API_TOKEN}
  only:
    - master

.pull-to-prod:
  stage: deploy-prod
  needs:
    - push-from-prod
  before_script:
    - *ssh-key-install
  script:
    - curl -LO "${CI_REPO_URL}/bitrix-projects/legacy/deploy.sh"
    - chmod +x deploy.sh

    - export CMD="cd ${PRODUCTION_ROOTPATH} && bash -s"
    - ssh -p ${PRODUCTION_SSH_PORT} ${PRODUCTION_USER}@${PRODUCTION_HOST} "${CMD}" < ./deploy.sh
  environment:
    name: production
  only:
    - master
